[leetcode] two sum

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:
Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

  • 暴力

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    class {
    public int[] twoSum(int[] nums, int target) {
    for (int i = 0; i < nums.length; i++) {
    for (int j = i + 1; j < nums.length; j++) {
    if (nums[i] + nums[j] == target) {
    return new int[]{i, j};
    }
    }
    }
    throw new IllegalArgumentException("No two sum solution");
    }
    }
  • HashMap

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    public int[] twoSum(int[] nums, int target) {
    HashMap<Integer, Integer> map = new HashMap<>();
    for (int i = 0; i < nums.length; i++) {
    if (map.containsKey(target - nums[i])) {
    return new int[]{i, map.get(target - nums[i])};
    }
    map.put(nums[i],i);
    }
    throw new IllegalArgumentException("No two sum solution");
    }